Index: core/roslib/src/roslib/names.py
===================================================================
--- core/roslib/src/roslib/names.py	(revision 12349)
+++ core/roslib/src/roslib/names.py	(working copy)
@@ -55,6 +55,15 @@
 REMAP = ":="
 ANYTYPE = '*'
 
+def isstring(s):
+    """Small helper version to check an object is a string in a way that works
+    for both Python 2 and 3
+    """
+    try:
+        return isinstance(s, basestring) #Python 2.x
+    except NameError:
+        return isinstance(s, str) #Python 3.x
+
 def get_ros_namespace(env=None, argv=None):
     """
     @param env: environment dictionary (defaults to os.environ)
@@ -142,7 +151,7 @@
     "map name to its namespace"
     if name is None: 
         raise ValueError('name')
-    if not isinstance(name, basestring):
+    if not isstring(name):
         raise TypeError('name')
     if not name:
         return SEP
@@ -194,7 +203,7 @@
                     else:
                         mappings[src] = dst
             except:
-                print >> sys.stderr, "ERROR: Invalid remapping argument '%s'"%arg
+                sys.stderr.write("ERROR: Invalid remapping argument '%s'\n"%arg)
     return mappings
 
 #######################################################################
@@ -268,7 +277,7 @@
 
 def _is_safe_name(name, type_name):
     #windows long-file name length is 255
-    if not isinstance(name, basestring) or not name or len(name) > 255:
+    if not isstring(name) or not name or len(name) > 255:
         return False
     return is_legal_resource_name(name)
 
@@ -289,7 +298,7 @@
     @type  name: str
     """
     # resource names can be unicode due to filesystem
-    if name is None or not isinstance(name, basestring):
+    if name is None or not isstring(name):
         return False
     m = RESOURCE_NAME_LEGAL_CHARS_P.match(name)
     # '//' check makes sure there isn't double-slashes
@@ -308,7 +317,7 @@
     @type  name: str
     """    
     # should we enforce unicode checks?
-    if name is None or not isinstance(name, basestring):
+    if name is None or not isstring(name):
         return False
     # empty string is a legal name as it resolves to namespace
     if name == '':
@@ -322,7 +331,7 @@
     Validates that name is a legal base name for a graph resource. A base name has
     no namespace context, e.g. "node_name".
     """
-    if name is None or not isinstance(name, basestring):
+    if name is None or not isstring(name):
         return False
     m = BASE_NAME_LEGAL_CHARS_P.match(name)
     return m is not None and m.group(0) == name
@@ -334,7 +343,7 @@
     no package context, e.g. "String".
     """
     # resource names can be unicode due to filesystem
-    if name is None or not isinstance(name, basestring):
+    if name is None or not isstring(name):
         return False
     m = BASE_NAME_LEGAL_CHARS_P.match(name)
     return m is not None and m.group(0) == name
@@ -395,7 +404,7 @@
     @type  id: str
     """
     import socket, random
-    name = "%s_%s_%s_%s"%(id, socket.gethostname(), os.getpid(), random.randint(0, sys.maxint))
+    name = "%s_%s_%s_%s"%(id, socket.gethostname(), os.getpid(), random.randint(0, sys.maxsize))
     # RFC 952 allows hyphens, IP addrs can have '.'s, both
     # of which are illegal for ROS names. For good
     # measure, screen ipv6 ':'. 
Index: core/roslib/src/roslib/xmlrpc.py
===================================================================
--- core/roslib/src/roslib/xmlrpc.py	(revision 12349)
+++ core/roslib/src/roslib/xmlrpc.py	(working copy)
@@ -43,20 +43,43 @@
 import logging
 import socket
 import string
-import thread
+
+try:
+    import _thread
+except ImportError:
+    import thread as _thread
+
 import traceback
-from SimpleXMLRPCServer import SimpleXMLRPCServer, SimpleXMLRPCRequestHandler
-import SocketServer
 
+try:
+    from xmlrpc.server import SimpleXMLRPCServer, SimpleXMLRPCRequestHandler #Python 3.x
+except ImportError:
+    from SimpleXMLRPCServer import SimpleXMLRPCServer #Python 2.x
+    from SimpleXMLRPCServer import SimpleXMLRPCRequestHandler #Python 2.x
+
+try:
+    import socketserver
+except ImportError:
+    import SocketServer as socketserver
+
 import roslib.network
 import roslib.exceptions
 
+def isstring(s):
+    """Small helper version to check an object is a string in a way that works
+    for both Python 2 and 3
+    """
+    try:
+        return isinstance(s, basestring)
+    except NameError:
+        return isinstance(s, str)
+
 class SilenceableXMLRPCRequestHandler(SimpleXMLRPCRequestHandler):
     def log_message(self, format, *args):
         if DEBUG:
             SimpleXMLRPCRequestHandler.log_message(self, format, *args)
     
-class ThreadingXMLRPCServer(SocketServer.ThreadingMixIn, SimpleXMLRPCServer):
+class ThreadingXMLRPCServer(socketserver.ThreadingMixIn, SimpleXMLRPCServer):
     """
     Adds ThreadingMixin to SimpleXMLRPCServer to support multiple concurrent
     requests via threading. Also makes logging toggleable.
@@ -80,7 +103,7 @@
             if logger:
                 logger.error(traceback.format_exc())
     
-class ForkingXMLRPCServer(SocketServer.ForkingMixIn, SimpleXMLRPCServer):
+class ForkingXMLRPCServer(socketserver.ForkingMixIn, SimpleXMLRPCServer):
     """
     Adds ThreadingMixin to SimpleXMLRPCServer to support multiple concurrent
     requests via forking. Also makes logging toggleable.      
@@ -126,8 +149,8 @@
         self.handler = rpc_handler
         self.uri = None # initialize the property now so it can be tested against, will be filled in later
         self.server = None
-        if port and isinstance(port, basestring):
-            port = string.atoi(port)
+        if port and isstring(port):
+            port = int(port)
         self.port = port
         self.is_shutdown = False
         self.on_run_error = on_run_error
@@ -153,7 +176,7 @@
         """
         Initiate a thread to run the XML RPC server. Uses thread.start_new_thread.
         """
-        thread.start_new_thread(self.run, ())
+        _thread.start_new_thread(self.run, ())
 
     def set_uri(self, uri):
         """
@@ -167,7 +190,7 @@
     def run(self):
         try:
             self._run()
-        except Exception, e:
+        except Exception as e:
             if self.on_run_error is not None:
                self.on_run_error(e)
             else:
@@ -219,13 +242,14 @@
             self.server.register_multicall_functions()
             self.server.register_instance(self.handler)
 
-        except socket.error, (n, errstr):
+        except socket.error as e:
+            (n, errstr) = e
             if n == 98:
                 msg = "ERROR: Unable to start XML-RPC server, port %s is already in use"%self.port
             else:
                 msg = "ERROR: Unable to start XML-RPC server: %s"%errstr                
             logger.error(msg)
-            print msg
+            print(msg)
             raise #let higher level catch this
 
         if self.handler is not None:
Index: core/roslib/src/roslib/manifest.py
===================================================================
--- core/roslib/src/roslib/manifest.py	(revision 12349)
+++ core/roslib/src/roslib/manifest.py	(working copy)
@@ -93,7 +93,7 @@
 Package '%(package_dir)s' is improperly configured: no manifest file is present.
 """%locals())
         return p
-    except roslib.packages.InvalidROSPkgException, e:
+    except roslib.packages.InvalidROSPkgException as e:
         if required:
             raise
 
Index: core/roslib/src/roslib/os_detect.py
===================================================================
--- core/roslib/src/roslib/os_detect.py	(revision 12349)
+++ core/roslib/src/roslib/os_detect.py	(working copy)
@@ -36,8 +36,8 @@
 command-line tool.
 """
 
-from __future__ import with_statement
 
+
 import roslib.exceptions
 import roslib.rospack
 import roslib.stacks
@@ -192,7 +192,7 @@
                 if os_list[0] == "Fedora" and os_list[1] == "release":
                     return os_list[2]
         except:
-            print "Fedora failed to get version"
+            print("Fedora failed to get version")
             return False
 
         return False
@@ -228,7 +228,7 @@
                 if os_list and os_list[2] == "Enterprise":
                     return os_list[6]
         except:
-            print "Rhel failed to get version"
+            print("Rhel failed to get version")
             return False
 
         return False
@@ -290,7 +290,7 @@
                 if os_list[0] == "Linux" and os_list[1] == "Arch":
                     return os_list[2]
         except:
-            print "Arch failed to get version"
+            print("Arch failed to get version")
             return False
 
         return False
@@ -349,7 +349,7 @@
                 if os_list[0] == "Gentoo" and os_list[1] == "Base":
                     return os_list[4]
         except:
-            print >> sys.stderr, "Gentoo failed to get version"
+            sys.stderr.write("Gentoo failed to get version\n")
             return False
 
         return False
@@ -388,7 +388,7 @@
             else:
                return False
         except:
-            print >> sys.stderr, "FreeBSD failed to get version"
+            sys.stderr.write("FreeBSD failed to get version\n")
             return False
 
         return False
@@ -407,7 +407,7 @@
     def check_presence(self):
         try:
             (self._os_name, self._os_version) = os.environ["ROS_OS_OVERRIDE"].split(':')
-            print >> sys.stderr, "Using environment variable ROS_OS_OVERRIDE name = %s version = %s"%(self._os_name, self._os_version)
+            sys.stderr.write("Using environment variable ROS_OS_OVERRIDE name = %s version = %s\n"%(self._os_name, self._os_version))
             return True
         except:
             return False
Index: core/roslib/src/roslib/msgs.py
===================================================================
--- core/roslib/src/roslib/msgs.py	(revision 12349)
+++ core/roslib/src/roslib/msgs.py	(working copy)
@@ -38,7 +38,11 @@
 Implements: U{http://ros.org/wiki/msg}
 """
 
-import cStringIO
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
 import os
 import itertools
 import sys
@@ -234,7 +238,7 @@
     @rtype: str
     """
     if buff is None:
-        buff = cStringIO.StringIO()
+        buff = StringIO()
     for c in spec.constants:
         buff.write("%s%s %s=%s\n"%(indent, c.type, c.name, c.val_text))
     for type_, name in zip(spec.types, spec.names):
@@ -310,7 +314,7 @@
         @return: zip list of types and names (e.g. [('int32', 'x'), ('int32', 'y')]
         @rtype: [(str,str),]
         """
-        return zip(self.types, self.names)
+        return list(zip(self.types, self.names))
     
     def parsed_fields(self):
         """
@@ -373,7 +377,7 @@
     
     header = os.path.join(roslib_dir, roslib.packages.MSG_DIR, fname)
     if not os.path.isfile(header):
-        print >> sys.stderr, "ERROR: cannot locate %s. Excepted to find it at '%s'"%(fname, header)
+        sys.stderr.write("ERROR: cannot locate %s. Excepted to find it at '%s'\n"%(fname, header))
         return False
 
     # register Header under both contexted and de-contexted name
@@ -382,7 +386,7 @@
     register('std_msgs/'+HEADER, spec)    
     # backwards compat, REP 100
     register('roslib/'+HEADER, spec)    
-    for k, spec in EXTENDED_BUILTINS.iteritems():
+    for k, spec in EXTENDED_BUILTINS.items():
         register(k, spec)
         
     _initialized = True
@@ -440,9 +444,9 @@
         try: 
             typespec = load_from_file(msg_file(package, t), package)
             specs.append(typespec)
-        except Exception, e:
+        except Exception as e:
             failures.append(t)
-            print "ERROR: unable to load %s"%t
+            print("ERROR: unable to load %s"%t)
     return specs, failures
 
 def load_package_dependencies(package, load_recursive=False):
@@ -457,7 +461,7 @@
     global _loaded_packages
     _init()    
     if VERBOSE:
-        print "Load dependencies for package", package
+        print("Load dependencies for package", package)
         
     if not load_recursive:
         manifest_file = roslib.manifest.manifest_file(package, True)
@@ -470,7 +474,7 @@
     failures = []
     for d in depends:
         if VERBOSE:
-            print "Load dependency", d
+            print("Load dependency", d)
         #check if already loaded
         # - we are dependent on manifest.getAll returning first-order dependencies first
         if d in _loaded_packages or d == package:
@@ -495,19 +499,19 @@
     global _loaded_packages
     _init()    
     if VERBOSE:
-        print "Load package", package
+        print("Load package", package)
         
     #check if already loaded
     # - we are dependent on manifest.getAll returning first-order dependencies first
     if package in _loaded_packages:
         if VERBOSE:
-            print "Package %s is already loaded"%package
+            print("Package %s is already loaded"%package)
         return
 
     _loaded_packages.append(package)
     specs, failed = get_pkg_msg_specs(package)
     if VERBOSE:
-        print "Package contains the following messages: %s"%specs
+        print("Package contains the following messages: %s"%specs)
     for key, spec in specs:
         #register spec under both local and fully-qualified key
         register(key, spec)
@@ -588,7 +592,7 @@
         l = orig_line.split(COMMENTCHAR)[0].strip() #strip comments
         if not l:
             continue #ignore empty lines
-        splits = filter(lambda s: s, [x.strip() for x in l.split(" ")]) #split type/name, filter out empties
+        splits = [s for s in [x.strip() for x in l.split(" ")] if s] #split type/name, filter out empties
         type_ = splits[0]
         if not is_valid_msg_type(type_):
             raise MsgSpecException("%s is not a legal message type"%type_)
@@ -608,7 +612,7 @@
                 val = splits[1]
             try:
                 val_converted  = _convert_val(type_, val)
-            except Exception, e:
+            except Exception as e:
                 raise MsgSpecException("Invalid declaration: %s"%e)
             constants.append(Constant(type_, name, val_converted, val.strip()))
         else:
@@ -640,9 +644,9 @@
     """
     if VERBOSE:
         if package_context:
-            print "Load spec from", file_path, "into package [%s]"%package_context
+            print("Load spec from", file_path, "into package [%s]"%package_context)
         else:
-            print "Load spec from", file_path
+            print("Load spec from", file_path)
 
     file_name = os.path.basename(file_path)
     type_ = file_name[:-len(EXT)]
@@ -660,7 +664,7 @@
         try:
             text = f.read()
             return (type_, load_from_string(text, package_context, type_, base_type_))
-        except MsgSpecException, e:
+        except MsgSpecException as e:
             raise MsgSpecException('%s: %s'%(file_name, e))
     finally:
         f.close()
@@ -725,7 +729,7 @@
     registered. NOTE: builtin types are not registered.
     @rtype: bool
     """
-    return REGISTERED_TYPES.has_key(msg_type_name)
+    return msg_type_name in REGISTERED_TYPES
 
 def get_registered(msg_type_name, default_package=None):
     """
@@ -753,6 +757,6 @@
     @type  msg_spec: L{MsgSpec}
     """
     if VERBOSE:
-        print "Register msg %s"%msg_type_name
+        print("Register msg %s"%msg_type_name)
     REGISTERED_TYPES[msg_type_name] = msg_spec
 
Index: core/roslib/src/roslib/resources.py
===================================================================
--- core/roslib/src/roslib/resources.py	(revision 12349)
+++ core/roslib/src/roslib/resources.py	(working copy)
@@ -81,8 +81,8 @@
     if include_depends:
         depends = _get_manifest_by_dir(package_dir).depends
         dirs = [roslib.packages.get_pkg_subdir(d.package, subdir, False) for d in depends]
-        dirs = filter(lambda dir: dir and os.path.isdir(dir), dirs)
-        for (dep, dir) in itertools.izip(depends, dirs):
+        dirs = [dir for dir in dirs if dir and os.path.isdir(dir)]
+        for (dep, dir) in zip(depends, dirs):
             resources.extend(\
                 [roslib.names.resource_name(dep.package, f, my_pkg=package) \
                  for f in os.listdir(dir) if rfilter(os.path.join(dir, f))])
Index: core/roslib/src/roslib/roslogging.py
===================================================================
--- core/roslib/src/roslib/roslogging.py	(revision 12349)
+++ core/roslib/src/roslib/roslogging.py	(working copy)
@@ -80,7 +80,7 @@
             makedirs_with_parent_perms(logfile_dir)
         except OSError:
             # cannot print to screen because command-line tools with output use this
-            print >> sys.stderr, "WARNING: cannot create log directory [%s]. Please set %s to a writable location."%(logfile_dir, ROS_LOG_DIR)
+            sys.stderr.write("WARNING: cannot create log directory [%s]. Please set %s to a writable location.\n"%(logfile_dir, ROS_LOG_DIR))
             return None
     elif os.path.isfile(logfile_dir):
         raise roslib.exceptions.ROSLibException("Cannot save log files: file [%s] is in the way"%logfile_dir)
@@ -92,7 +92,7 @@
 
     if not os.path.isfile(config_file):
         # logging is considered soft-fail
-        print >> sys.stderr, "WARNING: cannot load logging configuration file, logging is disabled"
+        sys.stderr.write("WARNING: cannot load logging configuration file, logging is disabled\n")
         return log_filename
     
     # pass in log_filename as argument to pylogging.conf
Index: core/roslib/src/roslib/rosenv.py
===================================================================
--- core/roslib/src/roslib/rosenv.py	(revision 12349)
+++ core/roslib/src/roslib/rosenv.py	(working copy)
@@ -80,31 +80,31 @@
         env = os.environ
     p = None
     try:
-        if not env.has_key(ROS_ROOT):
-            raise ROSEnvException, """
+        if ROS_ROOT not in env:
+            raise ROSEnvException("""
 The %(ROS_ROOT)s environment variable has not been set.
 Please set to the location of your ROS installation
 before continuing.
-"""%globals()
+"""%globals())
 
         p = env[ROS_ROOT]
         #Test:
         # 1. Is a path
         # 2. Is a directory
         if not os.path.exists(p):
-            raise ROSEnvException, """
+            raise ROSEnvException("""
 The %s environment variable has not been set properly:
 %s does not exist.
 Please update your ROS installation before continuing.
-"""%(ROS_ROOT, p)
+"""%(ROS_ROOT, p))
         if not os.path.isdir(p):
-            raise ROSEnvException, """
+            raise ROSEnvException("""
 The %s environment variable has not been set properly:
 %s is not a directory.
 Please update your ROS installation before continuing.
-"""%(ROS_ROOT, p)
+"""%(ROS_ROOT, p))
         return p
-    except Exception, e:
+    except Exception as e:
         if required:
             raise
         return p
@@ -121,7 +121,7 @@
         env = os.environ
     try:
         return env[ROS_PACKAGE_PATH]
-    except KeyError, e:
+    except KeyError as e:
         if required:
             raise ROSEnvException("%s has not been configured"%ROS_PACKAGE_PATH)
 
@@ -158,7 +158,7 @@
                     raise ROSEnvException("__master remapping argument '%s' improperly specified"%arg)
                 return val
         return env[ROS_MASTER_URI]
-    except KeyError, e:
+    except KeyError as e:
         if required:
             raise ROSEnvException("%s has not been configured"%ROS_MASTER_URI)
         
Index: core/roslib/src/roslib/packages.py
===================================================================
--- core/roslib/src/roslib/packages.py	(revision 12349)
+++ core/roslib/src/roslib/packages.py	(working copy)
@@ -42,8 +42,8 @@
 in very experimental.
 """
 
-from __future__ import with_statement
 
+
 import os
 import sys
 import stat
@@ -220,11 +220,11 @@
         # rospack_cache as it will corrupt list_pkgs() otherwise.
         #_pkg_dir_cache[package] = (pkg_dir, ros_root, ros_package_path)
         return pkg_dir
-    except OSError, e:
+    except OSError as e:
         if required:
             raise InvalidROSPkgException("Environment configuration is invalid: cannot locate rospack (%s)"%e)
         return None
-    except Exception, e:
+    except Exception as e:
         if required:
             raise
         return None
@@ -264,7 +264,7 @@
 Please check permissions and try again.
 """%locals())
         return dir
-    except Exception, e:
+    except Exception as e:
         if required:
             raise
         return None
@@ -399,9 +399,9 @@
             # cache in most optimal way
             cache = _pkg_dir_cache
             if cache:
-                return cache.keys()
+                return list(cache.keys())
             if _update_rospack_cache():
-                return cache.keys()
+                return list(cache.keys())
     else:
         import warnings
         warnings.warn("pkg_dirs argument is deprecated. Please use list_pkgs_by_path() instead", DeprecationWarning, stacklevel=2)
@@ -572,7 +572,7 @@
     manifests = [load_manifest(p) for p in packages]
     import itertools
     map = {}
-    for pkg, m in itertools.izip(packages, manifests):
+    for pkg, m in zip(packages, manifests):
         map[pkg] = [d.name for d in m.rosdeps]
     return map
 
Index: core/roslib/src/roslib/genpy.py
===================================================================
--- core/roslib/src/roslib/genpy.py	(revision 12349)
+++ core/roslib/src/roslib/genpy.py	(working copy)
@@ -58,7 +58,10 @@
 import traceback
 import struct
 
-from cStringIO import StringIO
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
 
 import roslib.exceptions
 import roslib.gentools
@@ -108,7 +111,7 @@
     }
 
 ## Simple types are primitives with fixed-serialization length
-SIMPLE_TYPES = SIMPLE_TYPES_DICT.keys()
+SIMPLE_TYPES = list(SIMPLE_TYPES_DICT.keys())
 
 def is_simple(type_):
     """
@@ -743,7 +746,7 @@
 
     except MsgGenerationException:
         raise #re-raise
-    except Exception, e:
+    except Exception as e:
         raise MsgGenerationException(e) #wrap
     
 def complex_serializer_generator(package, type_, name, serialize, is_numpy):
@@ -1179,17 +1182,17 @@
     # types. The types have to be registered globally in order for
     # message generation of dependents to work correctly.
     roslib.msgs.reinit()
-    for t, spec in specs.iteritems():
+    for t, spec in specs.items():
         roslib.msgs.register(t, spec)
 
     # process actual MsgSpecs: we accumulate them into a single file,
     # rewriting the generated text as needed
     buff = StringIO()
-    for t, spec in specs.iteritems():
+    for t, spec in specs.items():
         pkg, s_type = roslib.names.package_resource_name(t)
         # dynamically generate python message code
         for l in msg_generator(pkg, s_type, spec):
-            l = _gen_dyn_modify_references(l, specs.keys())
+            l = _gen_dyn_modify_references(l, list(specs.keys()))
             buff.write(l + '\n')
     full_text = buff.getvalue()
 
@@ -1212,7 +1215,7 @@
 
     # finally, retrieve the message classes from the dynamic module
     messages = {}
-    for t in specs.iterkeys():
+    for t in specs.keys():
         pkg, s_type = roslib.names.package_resource_name(t)
         try:
             messages[t] = getattr(mod, _gen_dyn_name(pkg, s_type))
Index: core/roslib/src/roslib/rostime.py
===================================================================
--- core/roslib/src/roslib/rostime.py	(revision 12349)
+++ core/roslib/src/roslib/rostime.py	(working copy)
@@ -126,7 +126,7 @@
         @return: time as nanoseconds
         @rtype: long
         """
-        return self.secs * long(1e9) + self.nsecs
+        return self.secs * int(1e9) + self.nsecs
         
     def __hash__(self):
         """
@@ -140,7 +140,7 @@
     def __repr__(self):
         return "rostime.TVal[%d]"%self.to_nsec()
 
-    def __nonzero__(self):
+    def __bool__(self):
         """
         Check if time value is zero
         """
@@ -418,7 +418,7 @@
         @rtype:  L{Duration}
         """
         t = type(val)
-        if t in (int, long):
+        if t in (int, int):
             return Duration(self.secs * val, self.nsecs * val)
         elif t == float:
             return Duration.from_sec(self.to_sec() * val)
@@ -434,7 +434,7 @@
         @rtype:  L{Duration}
         """
         t = type(val)
-        if t in (int, long):
+        if t in (int, int):
             return Duration(self.secs // val, self.nsecs // val)
         elif t == float:
             return Duration.from_sec(self.to_sec() // val)
@@ -451,7 +451,7 @@
         """
         # unlike __floordiv__, this uses true div for float arg
         t = type(val)
-        if t in (int, long):
+        if t in (int, int):
             return Duration(self.secs // val, self.nsecs // val)
         elif t == float:
             return Duration.from_sec(self.to_sec() / val)
@@ -467,7 +467,7 @@
         @rtype:  L{Duration}
         """
         t = type(val)
-        if t in (int, long):
+        if t in (int, int):
             return Duration(self.secs / val, self.nsecs / val)
         elif t == float:
             return Duration.from_sec(self.to_sec() / val)
Index: core/roslib/src/roslib/params.py
===================================================================
--- core/roslib/src/roslib/params.py	(revision 12349)
+++ core/roslib/src/roslib/params.py	(working copy)
@@ -37,7 +37,7 @@
 """
 
 import sys
-import xmlrpclib
+from . import xmlrpc
 
 import roslib.rosenv
 from roslib.names import REMAP
@@ -55,8 +55,8 @@
     """    
     try:
         import yaml
-    except ImportError, e:
-        print >> sys.stderr, "Cannot import yaml. Please make sure the pyyaml system dependency is installed"
+    except ImportError as e:
+        sys.stderr.write("Cannot import yaml. Please make sure the pyyaml system dependency is installed\n")
         raise e
     mappings = {}
     for arg in argv:
@@ -67,7 +67,7 @@
                     if len(src) > 1 and src[0] == '_' and src[1] != '_':
                         mappings[src[1:]] = yaml.load(dst)
             except:
-                print >> sys.stderr, "ERROR: Invalid remapping argument '%s'"%arg
+                sys.stderr.write("ERROR: Invalid remapping argument '%s'\n"%arg)
     return mappings
 
 def get_param(key):
@@ -82,7 +82,7 @@
     """
     global _param_server
     if _param_server is None:
-        _param_server = xmlrpclib.ServerProxy(roslib.rosenv.get_master_uri())
+        _param_server = xmlrpc.client.ServerProxy(roslib.rosenv.get_master_uri())
     code, status, value = _param_server.getParam('/roslib', key)
     if code != 1: #unwrap value with Python semantics
         raise KeyError(key)
